unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
const
  PI = 3.141592654; //constant declaraion
  a : integer = 33; {typed constant declaration that
      force a constant to be of a particular data type.}

var
   //String types :
   achar : char;               //A char is a single character.
   aShortString : ShortString; //Short strings have a maximum length of 255 characters
   aString : String;           {If it is on $H+ string without length specifier
       will define an AnsiString (default), otherwise if the switch is off $H- then any
       string declaration will define a ShortString. }


   //Integer Types :
   //Max rage = (2^(8*Bytes))-1 for unsigned types
   abyte : byte;         //0 .. 255                                    Bytes : 1 unsigned
   aShortint : Shortint; //-128 .. 127                                 Bytes : 1 signed
   aWord : Word; 	   //0 .. 65535                                  Bytes : 2 unsigned
   aSmallint : Smallint; //-32768 .. 32767                             Bytes : 2 signed
   aCardinal : Cardinal; //0..4294967295  	                         Bytes : 4 unsigned
   aLongword : Longword; //0..4294967295 	                         Bytes : 4 unsigned
   aInteger : Integer;   //-2147483648 .. 2147483647 	                 Bytes : 4 signed
   aLongint : Longint;   //-2147483648 .. 2147483647 	                 Bytes : 4 signed
   aQWord : QWord; 	   //0 .. 18446744073709551615 	                 Bytes : 8 unsigned
   aInt64 : Int64; 	   //-9223372036854775808 .. 9223372036854775807 Bytes : 8 signed

   //Real Type :
   aSingle : Single;
   aDouble : Double;

   //Boolean :
   aBoolean,bBoolean : Boolean;

   //Extra
   counter, age : integer;
   isOld : boolean = true; //initialize this variable to true

begin

    //Assign constants NOT ALLOWED
    //PI := 3; //THIS IS INCORRECT You can not assign a constant

    //Assign variables
    achar:='C';
    aShortString:='Short string';
    aString:='String normal';

    abyte:=255;
    aShortint:=127;
    aWord:=65535;
    aSmallint:=32767;
    aCardinal:=4294967295;
    aLongword:=4294967295;
    aInteger:=2147483647;
    aLongint:=2147483647;
    aQWord:=18446744073709551615;
    aInt64:=9223372036854775807;

    aSingle:=1.75;
    aDouble:=2.5E100; //2.5^100

    aBoolean:=true;
    bBoolean:=false;

    counter:=0;
    age:=20;
    isOld:=false;

    //print variables
    Memo1.Lines.Add(achar);
    Memo1.Lines.Add(aShortString);
    Memo1.Lines.Add(aString);

    Memo1.Lines.Add(IntToStr(abyte)); //IntToStr : convert integer into string
    Memo1.Lines.Add(IntToStr(aShortint));
    Memo1.Lines.Add(IntToStr(aWord));
    Memo1.Lines.Add(IntToStr(aSmallint));
    Memo1.Lines.Add(IntToStr(aCardinal));
    Memo1.Lines.Add(IntToStr(aLongword));
    Memo1.Lines.Add(IntToStr(aInteger));
    Memo1.Lines.Add(IntToStr(aLongint));
    Memo1.Lines.Add(IntToStr(aQWord));
    Memo1.Lines.Add(IntToStr(aInt64));

    Memo1.Lines.Add(FloatToStr(aSingle)); //FloatToStr : convert float into string
    Memo1.Lines.Add(FloatToStr(aDouble));

    Memo1.Lines.Add(BoolToStr(aBoolean)); //-1 : true //BoolToStr : convert boolean into string
    Memo1.Lines.Add(BoolToStr(bBoolean)); // 0 : false

    Memo1.Lines.Add('Counter: ' + IntToStr(counter)); //string concatenation
    Memo1.Lines.Add('Age: ' + IntToStr(age));  //string concatenation
    Memo1.Lines.Add(BoolToStr(isOld)); //-1 : true


    Memo1.Lines.Add('PI: ' + FloatToStr(PI)); //string concatenation
    Memo1.Lines.Add('a integer constant: ' + IntToStr(a));  //string concatenation

end;

end.

